import System
import System.Text.RegularExpressions
import AlbumArtDownloader.Scripts
import util

class ccmpia(AlbumArtDownloader.Scripts.IScript):
	Name as string:
		get: return "ccmpia by artist"
	Version as string:
		get: return "0.1"
	Author as string:
		get: return "sheppaul"
	def Search(artist as string, album as string, results as IScriptResults):
		artist = EncodeUrl(StripCharacters("&.'\";:?!", artist))
		album = EncodeUrl(StripCharacters("&.'\";:?!", album))

		searchResultsHtml as string = GetPage("http://www.ccmpia.com/music/?m=search&section=album&q=${artist}")

		matches = Regex("album/(?<imgNum>[0-9]+).*name.>(?<title>.*)<", RegexOptions.IgnoreCase).Matches(searchResultsHtml)
		
		results.EstimatedCount = matches.Count
		
		for match as Match in matches:
			imagePart = match.Groups["imgNum"].Value
			thumbnail = "http://www.ccmpia.com/album/" + imagePart + "/image"
			full = "http://www.ccmpia.com/album/" + imagePart + "/image"
			title = match.Groups["title"].Value
			page = "http://www.ccmpia.com/album/" + imagePart
			
			results.Add(thumbnail, title, page, 200, 200, full, CoverType.Front)


	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter
