import System
import System.Text.RegularExpressions
import AlbumArtDownloader.Scripts
import util

class kyobo(AlbumArtDownloader.Scripts.IScript):
	Name as string:
		get: return "Kyobo"
	Version as string:
		get: return "0.1"
	Author as string:
		get: return "sheppaul"
	def Search(artist as string, album as string, results as IScriptResults):
		encoding = Encoding.GetEncoding("euc-kr")
		artist = EncodeUrl(StripCharacters("&.'\";:?!", artist), encoding)
		album = EncodeUrl(StripCharacters("&.'\";:?!", album), encoding)

		images_url = "http://www.kyobobook.co.kr/search/SearchMusicMain.jsp?vPstrCategory=MUC&vPsch=1&vPchgCategory=MUC&searchCategory=MUC&vPtagSearch=N&vPpopCategory=MUC&vPmallGb=MUC&vPplace=top&vPstrKeyWord=${artist}+${album}"
		searchResultsHtml as string = GetPage(GetPageStream(images_url, null, true), encoding)

		matches = Regex("l/(?<good>[0-9]+).*i/(?<dir>[0-9]+/)(?<file>[0-9]+).*e=.(?<title>.*)./>", RegexOptions.IgnoreCase).Matches(searchResultsHtml)
		
		results.EstimatedCount = matches.Count
		
		for match as Match in matches:
			goodN = match.Groups["good"].Value
			dirN = match.Groups["dir"].Value
			fileN = match.Groups["file"].Value
			thumbnail = "http://image.kyobobook.co.kr/newimages/music/midi/" + dirN + fileN + ".jpg"
			full = "http://image.kyobobook.co.kr/newimages/music/large/" + dirN + fileN + ".jpg"
			title = match.Groups["title"].Value
			title = title.Replace('<!HS>', '')
			title = title.Replace('<!HE>', '')
			page = "http://music.kyobobook.co.kr/ht/record/detail/" + goodN
			
			results.Add(thumbnail, title, page, 400, 400, full, CoverType.Front)


	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter