import System
import System.Text.RegularExpressions
import AlbumArtDownloader.Scripts
import util

class yes24(AlbumArtDownloader.Scripts.IScript):
	Name as string:
		get: return "Yes24"
	Version as string:
		get: return "0.1"
	Author as string:
		get: return "sheppaul"
	def Search(artist as string, album as string, results as IScriptResults):
		encoding = Encoding.GetEncoding("euc-kr")
		artist = EncodeUrl(StripCharacters("&.'\";:?!", artist), encoding)
		album = EncodeUrl(StripCharacters("&.'\";:?!", album), encoding)
		
		images_url = "http://www.yes24.com/searchcorner/Search?&domain=MUSIC&query=${artist}+${album}"
		searchResultsHtml as string = GetPage(GetPageStream(images_url, null, true), encoding)

		matches = Regex("A href=./24/goods/(?<imgNum>[0-9]+).*=(?<url>[0-9]+).*alt=\"(?<title>.*?)\"", RegexOptions.IgnoreCase).Matches(searchResultsHtml)
		
		results.EstimatedCount = matches.Count
		
		for match as Match in matches:
			imagePart = match.Groups["imgNum"].Value
			thumbnail = "http://image.yes24.com/goods/" + imagePart + ".jpg"
			full = "http://image.yes24.com/goods/" + imagePart + "/L.jpg"
			title = match.Groups["title"].Value
			page = "http://www.yes24.com/24/goods/" + imagePart + "?scode=029"
			
			results.Add(thumbnail, title, page, 400, 400, full, CoverType.Front)


	def RetrieveFullSizeImage(fullSizeCallbackParameter):
		return fullSizeCallbackParameter
